<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>library_dir_dir/include/rdc_tracing_fcns_.incl.pl1</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="pl1">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.LineNr { color: #585858; }
.Conditional { color: #af87d7; font-weight: bold; }
.Repeat { color: #af87d7; font-weight: bold; }
.Operator { color: #5fafd7; }
.Keyword { color: #00afaf; }
.Macro { color: #00afaf; }
.pliRainbow_lv1_p0 { color: #ffffe0; }
.Normal { color: #d0d0d0; background-color: #000000; padding-bottom: 1px; }
.Number { color: #ff5faf; }
.Boolean { color: #d7af00; font-weight: bold; }
.Function { color: #d0d0d0; }
.pliRainbow_lv0_o0 { color: #add8e6; }
.pliRainbow_lv0_p0 { color: #add8e6; }
.Comment { color: #808080; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span><span class="Comment">/*  START OF:       rdc_tracing_fcns_.incl.pl1                *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L4" class="LineNr">  4 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L5" class="LineNr">  5 </span>          <span class="Comment">/* N^H__^Ha_^Hm_^He: rdc_tracing_fcns_.incl.pl1                                                     */</span>
<span id="L6" class="LineNr">  6 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L7" class="LineNr">  7 </span>          <span class="Comment">/*      This include segment is used by compilers generated by the reduction_compiler.    */</span>
<span id="L8" class="LineNr">  8 </span>          <span class="Comment">/* It includes a PRINT_REDUCTION procedure which prints eached matched reduction, and a   */</span>
<span id="L9" class="LineNr">  9 </span>          <span class="Comment">/* PRINT_TOKENS procedure which print the tokens which match the reduction.  This output  */</span>
<span id="L10" class="LineNr"> 10 </span>          <span class="Comment">/* helps trace the flow of control through the reductions.                                */</span>
<span id="L11" class="LineNr"> 11 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L12" class="LineNr"> 12 </span>          <span class="Comment">/* E^H__^Hn_^Ht_^Hr_^Hy:  PRINT_REDUCTION                                                                     */</span>
<span id="L13" class="LineNr"> 13 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L14" class="LineNr"> 14 </span>          <span class="Comment">/*      This entry prints the matched reduction.                                          */</span>
<span id="L15" class="LineNr"> 15 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L16" class="LineNr"> 16 </span>          <span class="Comment">/* U^H__^Hs_^Ha_^Hg_^He                                                                                       */</span>
<span id="L17" class="LineNr"> 17 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L18" class="LineNr"> 18 </span>          <span class="Comment">/*      call PRINT_REDUCTION(NRED)                                                        */</span>
<span id="L19" class="LineNr"> 19 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L20" class="LineNr"> 20 </span>          <span class="Comment">/* 1) NRED   is the number of the matched reduction.                                      */</span>
<span id="L21" class="LineNr"> 21 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L22" class="LineNr"> 22 </span>          <span class="Comment">/* E^H__^Hn_^Ht_^Hr_^Hy:  PRINT_TOKENS                                                              */</span>
<span id="L23" class="LineNr"> 23 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L24" class="LineNr"> 24 </span>          <span class="Comment">/*      The entry prints the tokens which matched the matching reduction.                 */</span>
<span id="L25" class="LineNr"> 25 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L26" class="LineNr"> 26 </span>          <span class="Comment">/* U^H__^Hs_^Ha_^Hg_^He                                                                                       */</span>
<span id="L27" class="LineNr"> 27 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L28" class="LineNr"> 28 </span>          <span class="Comment">/*      call PRINT_TOKENS (DIRECTION, FIRST, LAST)                                        */</span>
<span id="L29" class="LineNr"> 29 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L30" class="LineNr"> 30 </span>          <span class="Comment">/* 1) DIRECTION     is +1 in a non-PUSH DDOWN  LANGUAGE translator, and -1 in a PUSH DOWN */</span>
<span id="L31" class="LineNr"> 31 </span>          <span class="Comment">/*                  LANGUAGE translator.                                                  */</span>
<span id="L32" class="LineNr"> 32 </span>          <span class="Comment">/* 2) FIRST         is number of the first syntax specification of this reduction.        */</span>
<span id="L33" class="LineNr"> 33 </span>          <span class="Comment">/* 3) LAST          is the number of the last syntax specification of this reduction.     */</span>
<span id="L34" class="LineNr"> 34 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L35" class="LineNr"> 35 </span>          <span class="Comment">/* S^H__^Ht_^Ha_^Ht_^Hu_^Hs                                                                                   */</span>
<span id="L36" class="LineNr"> 36 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L37" class="LineNr"> 37 </span>          <span class="Comment">/* 0) Created by:   G. C. Dixon, February, 1981 for reductions command, version 2.3       */</span>
<span id="L38" class="LineNr"> 38 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L39" class="LineNr"> 39 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span><span class="Normal">PRINT_REDUCTION</span><span class="Operator">:</span>
<span id="L42" class="LineNr"> 42 </span>          <span class="Keyword">proc</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">NRED</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>     <span class="Keyword">dcl</span>  <span class="Normal">NRED</span>                          <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>
<span id="L45" class="LineNr"> 45 </span>          <span class="Normal">ioa_</span>                          <span class="Keyword">entry</span><span class="pliRainbow_lv0_p0">()</span> <span class="Macro">options</span><span class="pliRainbow_lv0_p0">(</span><span class="Macro">variable</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>          <span class="Keyword">call</span> <span class="Normal">ioa_</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;^</span><span class="Keyword">a</span><span class="Operator">&quot;</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">RED_TEXT</span><span class="pliRainbow_lv1_p0">(</span><span class="Normal">NRED</span><span class="pliRainbow_lv1_p0">)</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>          <span class="Keyword">end</span> <span class="Normal">PRINT_REDUCTION</span><span class="Normal">;</span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>
<span id="L52" class="LineNr"> 52 </span><span class="Normal">PRINT_TOKENS</span><span class="Operator">:</span>
<span id="L53" class="LineNr"> 53 </span>          <span class="Keyword">proc</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">DIRECTION</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">FIRST</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">LAST</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L54" class="LineNr"> 54 </span>
<span id="L55" class="LineNr"> 55 </span>     <span class="Keyword">dcl</span>  <span class="Normal">DIRECTION</span>                     <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>
<span id="L56" class="LineNr"> 56 </span>         <span class="pliRainbow_lv0_p0">(</span><span class="Normal">FIRST</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">LAST</span><span class="pliRainbow_lv0_p0">)</span>                  <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">;</span>
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>     <span class="Keyword">dcl</span>  <span class="Normal">Itoken</span>                        <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>
<span id="L59" class="LineNr"> 59 </span>          <span class="Function">count</span>                         <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">;</span>
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>     <span class="Keyword">dcl</span>  <span class="Normal">ioa_$nnl</span>                      <span class="Keyword">entry</span><span class="pliRainbow_lv0_p0">()</span> <span class="Macro">options</span><span class="pliRainbow_lv0_p0">(</span><span class="Macro">variable</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L62" class="LineNr"> 62 </span>
<span id="L63" class="LineNr"> 63 </span>          <span class="Conditional">if</span> <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L64" class="LineNr"> 64 </span>               <span class="Keyword">call</span> <span class="Normal">ioa_$nnl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;&lt;</span><span class="Normal">NO</span> <span class="Normal">TOKENS</span> <span class="Normal">LEFT</span><span class="Operator">&gt;^/&quot;</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L65" class="LineNr"> 65 </span>               <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L66" class="LineNr"> 66 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>          <span class="Conditional">if</span> <span class="Normal">DIRECTION</span> <span class="Operator">=</span> <span class="Operator">-</span><span class="Number">1</span> <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>                        <span class="Comment">/* PUSH DOWN LANGUAGE                             */</span>
<span id="L69" class="LineNr"> 69 </span>               <span class="Function">count</span> <span class="Operator">=</span> <span class="Normal">FIRST</span> <span class="Operator">-</span> <span class="Normal">LAST</span> <span class="Operator">+</span> <span class="Number">1</span><span class="Normal">;</span>
<span id="L70" class="LineNr"> 70 </span>               <span class="Conditional">if</span> <span class="Function">count</span> <span class="Operator">=</span> <span class="Number">0</span> <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L71" class="LineNr"> 71 </span>                    <span class="Keyword">call</span> <span class="Normal">ioa_$nnl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;^/&quot;</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L72" class="LineNr"> 72 </span>                    <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L73" class="LineNr"> 73 </span>                    <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L74" class="LineNr"> 74 </span>               <span class="Normal">PTOKEN_REQD</span> <span class="Operator">=</span> <span class="Function">addr</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">TOKEN_REQUIREMENT</span><span class="pliRainbow_lv1_p0">(</span><span class="Normal">FIRST</span><span class="pliRainbow_lv1_p0">)</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L75" class="LineNr"> 75 </span>               <span class="Conditional">if</span> <span class="Normal">TOKEN_REQD</span><span class="Normal">.</span><span class="Normal">FORM</span> <span class="Operator">=</span> <span class="Number">0</span> <span class="Operator">&amp;</span> <span class="Normal">TOKEN_REQD</span><span class="Normal">.</span><span class="Normal">TYPE</span> <span class="Operator">=</span> <span class="Number">0</span> <span class="Keyword">then</span>
<span id="L76" class="LineNr"> 76 </span>                    <span class="Function">count</span> <span class="Operator">=</span> <span class="Function">count</span> <span class="Operator">-</span> <span class="Number">1</span><span class="Normal">;</span>                      <span class="Comment">/* A &lt;no-token&gt; syntax function does not match a  */</span>
<span id="L77" class="LineNr"> 77 </span>                                                            <span class="Comment">/*  token.                                        */</span>
<span id="L78" class="LineNr"> 78 </span>               <span class="Keyword">do</span> <span class="Normal">Itoken</span> <span class="Operator">=</span> <span class="Number">1</span> <span class="Keyword">to</span> <span class="Function">count</span><span class="Operator">-</span><span class="Number">1</span> <span class="Repeat">while</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">^=</span> <span class="Boolean">null</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L79" class="LineNr"> 79 </span>                    <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span><span class="Normal">;</span>
<span id="L80" class="LineNr"> 80 </span>                    <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L81" class="LineNr"> 81 </span>               <span class="Keyword">do</span> <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">Ptoken</span> <span class="Keyword">repeat</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Repeat">while</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Ptoken</span> <span class="Operator">^=</span> <span class="Normal">Pthis_token</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L82" class="LineNr"> 82 </span>                    <span class="Keyword">call</span> <span class="Normal">ioa_$nnl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;^</span><span class="Keyword">a</span> <span class="Operator">&quot;</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">token_value</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L83" class="LineNr"> 83 </span>                    <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L84" class="LineNr"> 84 </span>               <span class="Keyword">call</span> <span class="Normal">ioa_$nnl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;^</span><span class="Keyword">a</span><span class="Operator">^/&quot;</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">token_value</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L85" class="LineNr"> 85 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L86" class="LineNr"> 86 </span>          <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L87" class="LineNr"> 87 </span>               <span class="Function">count</span> <span class="Operator">=</span> <span class="Normal">LAST</span> <span class="Operator">-</span> <span class="Normal">FIRST</span> <span class="Operator">+</span> <span class="Number">1</span><span class="Normal">;</span>
<span id="L88" class="LineNr"> 88 </span>               <span class="Keyword">do</span> <span class="Normal">Itoken</span> <span class="Operator">=</span> <span class="Number">1</span> <span class="Keyword">to</span> <span class="Function">count</span><span class="Normal">;</span>
<span id="L89" class="LineNr"> 89 </span>                    <span class="Keyword">call</span> <span class="Normal">ioa_$nnl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;^</span><span class="Keyword">a</span> <span class="Operator">&quot;</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">token_value</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L90" class="LineNr"> 90 </span>                    <span class="Normal">Ptoken</span>  <span class="Operator">=</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span><span class="Normal">;</span>
<span id="L91" class="LineNr"> 91 </span>                    <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L92" class="LineNr"> 92 </span>               <span class="Keyword">call</span> <span class="Normal">ioa_$nnl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;^/&quot;</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L93" class="LineNr"> 93 </span>               <span class="Normal">Ptoken</span> <span class="Operator">=</span> <span class="Normal">Pthis_token</span><span class="Normal">;</span>
<span id="L94" class="LineNr"> 94 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>          <span class="Keyword">end</span> <span class="Normal">PRINT_TOKENS</span><span class="Normal">;</span>
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>
<span id="L100" class="LineNr">100 </span><span class="Comment">/*  END OF:         rdc_tracing_fcns_.incl.pl1                *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
